###########################################################################
# $Id: JSHttpRequest.p,v 1.12 2007-12-11 15:39:07 misha Exp $
#
# class JSHttpRequest for working with
#	JsHttpRequest <http://dklab.ru/lib/JsHttpRequest/>
#	by Dmitry Koterov
# based on some methods from Sergey M. <http://www.parser.ru/forum/?id=41408>
# changes for working with JsHttpRequest 5 from MadCow and Sergey M.
# table for decode %u0430 & Co based on Eugene Sperance table
#
###########################################################################


@CLASS
JSHttpRequest


###########################################################################
@auto[]
$sJsClassNameDefault[JsHttpRequest]
$bInitialized(0)

$sJsClassName[$sJsClassNameDefault]
$bOldStyle(0)
#end @auto[]



###########################################################################
@init[hParam][tField]
^if(def $hParam){
	$hParam[^hash::create[$hParam]]
	^if(def $hParam.sJsClassName){
		$sJsClassName[$hParam.sJsClassName]
	}
	^if(def $hParam.bOldStyle){
		$bOldStyle(^hParam.bOldStyle.int(0))
	}
	
	^if(def $hParam.bForce){
		$bInitialized(^hParam.bForce.int(0))
	}
	
	^if(def $hParam.bAllowUnicodeChars){
		$bAllowUnicodeChars(^hParam.bAllowUnicodeChars.int(0))
	}
}
^if(!$bInitialized){
	$bInitialized(1)

	$tField[^request:query.match[^^(?:.*)(?:&|^^)JsHttpRequest=(?:(\d+)-)?([^^&]+)((?:&|^$).*)^$]]
	$ID[$tField.1]
	$LOADER[$tField.2]
}
#end @init[]



###########################################################################
@decodeRequest[]
^if(^self._isForm[]){
	$result[^hash::create[$form:fields]]
}{
	$result[^self.decodeText[$request:query]]
	^if(def $request:body){^result.add[^self.decodeText[$request:body]]}
}
#end @decodeRequest[]



###########################################################################
@printResponse[sText;uVar][hData;hLoader]
^if($bOldStyle){
	$result[${sJsClassName}.dataReady('^self.getId[]', '$sText', ^self._object2js[$uVar])]
}{
	$hData[
		$.script[
			$.sContentType[text/javascript]
			$.sPrefix[${sJsClassName}.dataReady^(]
			$.sSuffix[^)]
		]
		$.xml[
			$.sContentType[text/plain]
			$.sPrefix[]
			$.sSuffix[]
		]
		$.form[
			$.sContentType[text/html]
			$.sPrefix[<script type="text/javascript" language="JavaScript"><!--
				top && top.JsHttpRequestGlobal && top.JsHttpRequestGlobal.dataReady^(
			]
			$.sSuffix[^)//--></script>]
		]
		$._default[
			$.sContentType[text/plain]
			$.sPrefix[]
			$.sSuffix[]
		]
	]
	$hLoader[$hData.[^self.getLoader[]]]
	$result[$hLoader.sPrefix { 'id':'^self.getId[]', 'js':^self._object2js[$uVar], 'text':'^taint[js][$sText]' } $hLoader.sSuffix]

	$response:content-type[
		$.value[$hLoader.sContentType]
		$.charset[$response:charset]
	]
}
#end @printResponse[]



###########################################################################
@decodeText[sText][_tmp]
^if(!def $tDecode){
	$tDecode[^self._getDecodeTable[]]
}

$result[^hash::create[]]

$_tmp[^sText.match[(?:^^|&|\?)([^^=]+)=([^^&]+)][gm]{$result.[^self._decode[$match.1]][^self._decode[$match.2]]}]
#end @decodeText[]



###########################################################################
@getId[]
^self.init[]
$result[$self.ID]
#end @getId[]



###########################################################################
@getLoader[]
^self.init[]
$result[$self.LOADER]
#end @getLoader[]



###########################################################################
@_isForm[]
^self.init[]
$result($self.LOADER eq "form")
#end @_isForm[]



###########################################################################
# carefull: for empty strings returned 'null'
@_object2js[uVar]
$result[]
^if(!(
	($uVar is "bool" && ($uVar && ^self._return[true] || ^self._return[false]))
	|| (!def $uVar && ^self._return[null])
	|| ($uVar is "string" && ^self._return[^self._string2js[$uVar]])
	|| ($uVar is "double" && ^self._return[$uVar])
	|| ($uVar is "int" && ^self._return[$uVar])
	|| ($uVar is "table" && (($uVar && ^self._return[^self._table2js[$uVar]]) || ^self._return[null]))
	|| ($uVar is "hash" && (($uVar && ^self._return[^self._hash2js[$uVar]]) || ^self._return[null]))
	|| ($uVar is "date" && ^self._return[new Date(^uVar.unix-timestamp[]000)])
)){
	^self._return[null]
}
#end @_object2js[]



###########################################################################
@_return[sType]
$caller.result[$sType]
$result(1)
#end @_return[]



###########################################################################
@_decode[sText]
$result[^taint[^sText.replace[$tDecode]]]
^if(def $result && $bAllowUnicodeChars){
	$result[^result.match[%u([\dA-F]{4})][gi]{&#x$match.1^;}]
}
#end @_decode[]



###########################################################################
@_string2js[sData]
$result['^taint[js][$sData]']
#end @_string2js[]



###########################################################################
@_hash2js[hData][bIsHashOfBool;sKey;uValue]
$bIsHashOfBool(1)
# check if our hash is hash of bool with only 'true' values
^hData.foreach[sKey;uValue]{
	^if($bIsHashOfBool && !($uValue is "bool" && $uValue)){
		$bIsHashOfBool(0)
	}
}

^if($bIsHashOfBool){
	$result[[
		^hData.foreach[sKey;]{
			^self._string2js[$sKey]
		}[, ]
	]]
}{
	^rem{ *** in other case return associated array *** }
	$result[{
		^hData.foreach[sKey;uValue]{
			^self._string2js[$sKey]:
			^if($uValue is "double" || $uValue is "bool" || $uValue is "int"){
				^self._object2js($uValue)
			}{
				^self._object2js[$uValue]
			}
		}[, ]
	}]
}
#end @_hash2js[]



###########################################################################
@_table2js[tData][tKeys]
$tKeys[^tData.columns[]]
^if($tKeys){
	$result[[
		^tData.menu{
			{
				^tKeys.menu{
					^self._string2js[$tKeys.column]:^self._string2js[$tData.[$tKeys.column]]
				}[, ]
			}
		}[, ]
	]]
}{
	^rem{ *** nameless tables are deprecated, lah. *** }
	$result[null]
}
#end @_table2js[]



###########################################################################
@_getDecodeTable[]
$result[^table::create{from	to
%0D%0A	^taint[^#0A]
%0D	^taint[^#0A]
%0A	^taint[^#0A]
%09	^taint[^#09]
%20	^#20
%21	!
%22	"
%23	#
%24	^$
%25	%
%26	&
%27	'
%28	(
%29	)
%2B	+
%2C	,
%3A	:
%3B	^;
%3C	<
%3D	=
%3E	>
%3F	?
%5B	^[
%5C	\
%5D	^]
%5E	^^
%60	`
%7B	^{
%7C	|
%7D	^}
%7E	~
%A0	^#A0
%A7	
%A9	
%AB	
%AE	
%B0	
%B1	
%BB	
%u0430	
%u0431	
%u0432	
%u0433	
%u0434	
%u0435	
%u0451	
%u0436	
%u0437	
%u0438	
%u0439	
%u043A	
%u043B	
%u043C	
%u043D	
%u043E	
%u043F	
%u0440	
%u0441	
%u0442	
%u0443	
%u0444	
%u0445	
%u0446	
%u0447	
%u0448	
%u0449	
%u044A	
%u044B	
%u044C	
%u044D	
%u044E	
%u044F	
%u0410	
%u0411	
%u0412	
%u0413	
%u0414	
%u0415	
%u0401	
%u0416	
%u0417	
%u0418	
%u0419	
%u041A	
%u041B	
%u041C	
%u041D	
%u041E	
%u041F	
%u0420	
%u0421	
%u0422	
%u0423	
%u0424	
%u0425	
%u0426	
%u0427	
%u0428	
%u0429	
%u042A	
%u042B	
%u042C	
%u042D	
%u042E	
%u042F	
%u2013	
%u2014	
%u201C	
%u201D	
%u201E	
%u2026	
%u2030	
%u20AC	
%u2116	
%u2122	
}]
#end @_getDecodeTable[]



